/*
 * Created with SharpDevelop.
 * User: Vincent
 * Date: 04/01/2005
 * Time: 17:46
 */
// one line to give the program's name and an idea of what it does.
// Copyright (C) yyyy  name of author
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

using System;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Windows.Forms;

namespace Server
{
	/// <summary>
	/// Description of ServerClass.
	/// </summary>
	public class ServerClass
	{
		/// <summary>
		/// 
		/// </summary>
		private Socket SocketServer;

		/// <summary>
		/// 
		/// </summary>
		private Socket SocketClient;
		
		/// <summary>
		/// 
		/// </summary>
		private bool LocalsocketClientIsShutingDown = false;

		/// <summary>
		/// tableau de byte pour la rception des messages.
		/// </summary>
		private byte[] readbuf;
		
		/// <summary>
		/// tableau de byte pour l'envoi des messages.
		/// </summary>
		private byte[] sendbuf;
		
		/// <summary>
		/// 
		/// </summary>
		private ListBox listBox;
		
		/// <summary>
		/// Dlgu permettant de faire les ajouts dans la listbox le tout dans le bon thread
		/// </summary>
		public delegate void DelegateDisplay(string message);
		
		/// <summary>
		/// 
		/// </summary>
		/// <param name="list"></param>
		public ServerClass(ListBox list)
		{	
			this.listBox = list;
			// Initialisation des buffers
			this.readbuf = new byte[100];
		}
		
		/// <summary>
		/// 
		/// </summary>
		public void RunServer()
		{
			// Cration socket serveur.
			this.SocketServer = new Socket(AddressFamily.InterNetwork,SocketType.Stream,ProtocolType.Tcp);
		
			IPAddress[] ipadress;
			//On rcupere les informations de l'ordinateur (son nom puis son adresse IP)
			IPHostEntry he = Dns.GetHostByName(Dns.GetHostName());
		 	ipadress = he.AddressList;
		 	
		 	//On lance l'coute sur le port voulu
		 	this.SocketServer.Bind(new IPEndPoint(ipadress[0],15));
		 	//On spcifie le nombre de connexion en attente maximun ici 1
		 	this.SocketServer.Listen(1);
			
		 	//On se met en attente de la connection d'un client 
			this.SocketServer.BeginAccept(new AsyncCallback(ConnectionAcceptCallback),this.SocketServer);
			
		}
		
		/// <summary>
		/// 
		/// </summary>
		/// <param name="asyncResult"></param>
		private void ConnectionAcceptCallback(IAsyncResult asyncResult)
		{
			string[] obj;

			try
			{
				//On rcupere le socket qui possede la connection
				Socket socket = (Socket)asyncResult.AsyncState;
				
				// Si le handle est  -1 --> La socket Serveur a t ferme.
				if (socket.Handle.ToInt32() != -1)
				{
					//on accepte la connection
					this.SocketClient = socket.EndAccept(asyncResult);
					this.LocalsocketClientIsShutingDown = false;
					//on ajoute un message dans la listbox
					obj = new string[1] {"Un client s'est connect"};
					this.listBox.Invoke(new DelegateDisplay(this.DisplayMessage),obj);
					//On se met en attente d'un message
					this.SocketClient.BeginReceive(this.readbuf, 0, this.readbuf.Length, SocketFlags.None, new AsyncCallback(ReceiveMessageCallback), this.SocketClient);
				}
			}
			catch (SocketException ex)
			{
				obj = new string[1] {ex.Message};
				this.listBox.Invoke(new DelegateDisplay(this.DisplayMessage),obj);				
			}

		}
		
		/// <summary>
		/// 
		/// </summary>
		public void ReceiveMessage()
		{
			if (this.SocketClient != null && this.SocketClient.Connected)
			{
				//On se met en attente d'un message
				this.SocketClient.BeginReceive(this.readbuf, 0, this.readbuf.Length, SocketFlags.None, new AsyncCallback(ReceiveMessageCallback), this.SocketClient);
			}
			else
			{
				DisplayMessage("Client non connect");
			}
		}
		
		/// <summary>
		/// 
		/// </summary>
		/// <param name="asyncResult"></param>
		private void ReceiveMessageCallback(IAsyncResult asyncResult)
		{
			string[] displaydata;
			try
			{
				//On rcupre le socket de la connection
				Socket socket = (Socket)asyncResult.AsyncState;
				//On lis les byte qui sont envoy par le client
				int read = socket.EndReceive(asyncResult);
						
				// On a reu des donnes
				if( read > 0 )
				{
					//on appel le dlgu qui s'occupe d'ajouter le message  la listbox le tout dans le bon thread
					displaydata = new string[] {"Client dit : " + Encoding.ASCII.GetString(this.readbuf)};
					this.listBox.Invoke(new DelegateDisplay(this.DisplayMessage), displaydata);
					// reset du buffer
					Buffer.SetByte(this.readbuf, 0, 0);
					//On se remet en attente d'un message
					this.SocketClient.BeginReceive(this.readbuf, 0, this.readbuf.Length, SocketFlags.None, new AsyncCallback(ReceiveMessageCallback), this.SocketClient);
				}
				// Fermeture socket distante. On ferme la socket cliente locale
				if( read == 0 && !this.LocalsocketClientIsShutingDown )
				{
					socket.Close();
					displaydata = new string[] {"Socket distante ferme."};
					this.listBox.Invoke(new DelegateDisplay(this.DisplayMessage), displaydata);
					//On se remet en attente de la connection d'un client 
					this.SocketServer.BeginAccept(new AsyncCallback(ConnectionAcceptCallback),this.SocketServer);
				}	
			}
			catch (SocketException ex)
			{
				displaydata = new string[] {ex.Message};
				this.listBox.Invoke(new DelegateDisplay(this.DisplayMessage), displaydata);
			}
		}
		
		/// <summary>
		/// 
		/// </summary>
		/// <param name="message"></param>
		public void Send(string message)
		{
			if (this.SocketClient != null && this.SocketClient.Connected)
			{
				//on converti la string en byte pour envois par le rseau
				this.sendbuf = Encoding.ASCII.GetBytes(message);
				//On envois le tout au client
				this.SocketClient.BeginSend(this.sendbuf, 0, this.sendbuf.Length, SocketFlags.None, new AsyncCallback(SendCallback), this.SocketClient);
			}
			else
			{
				DisplayMessage("Client non connect");
			}
		}
		
		/// <summary>
		/// 
		/// </summary>
		/// <param name="asyncResult"></param>
		private void SendCallback(IAsyncResult asyncResult)
		{
			string[] listdata;
			try
			{
				Socket socket = (Socket)asyncResult.AsyncState;
				//On met fin  l'envois de donne
				int send = socket.EndSend(asyncResult);
				
				//on ajoute un message  la listBox
				listdata = new string[1] {"Message envoy (" + send + " octets)"};
				this.listBox.Invoke(new DelegateDisplay(this.DisplayMessage), listdata);
			}
			catch (SocketException ex)
			{
				listdata = new string[] {ex.Message};
				this.listBox.Invoke(new DelegateDisplay(this.DisplayMessage), listdata);
			}

		}

		/// <summary>
		/// 
		/// </summary>
		public void CloseClient()
		{
			// Fermeture client
			if (this.SocketClient != null && this.SocketClient.Connected)
			{
				this.LocalsocketClientIsShutingDown = true;
				this.SocketClient.Shutdown(SocketShutdown.Both);
				//System.Threading.Thread.Sleep(1000);
				this.SocketClient.Close();
				//On se remet en attente de la connection d'un client 
				this.SocketServer.BeginAccept(new AsyncCallback(ConnectionAcceptCallback),this.SocketServer);

			}
			DisplayMessage("Client arrt");
		}
		
		/// <summary>
		/// 
		/// </summary>
		public void CloseServer()
		{
			// Fermeture client
			if (this.SocketClient != null && this.SocketClient.Connected)
				CloseClient();
			// Pas besoin de faire le shutdown sur la socket serveur.
			if (this.SocketServer != null && this.SocketServer.Handle.ToInt32() != -1)
				this.SocketServer.Close();
			DisplayMessage("Serveur arrt");
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="message"></param>
		private void DisplayMessage(string message)
		{
			this.listBox.Items.Add(message);
			this.listBox.SelectedIndex = this.listBox.Items.Count - 1;
		}
		
	}
}
